<?php

namespace App\Http\Controllers;

use App\Models\HomeBanner;
use App\Repositories\ResponseRepository;
use Illuminate\Support\Facades\Log;
use Illuminate\Http\Request;

class HomeBannerController extends Controller
{
    public function __construct(ResponseRepository $response) {
        $this->response = $response;
        $this->storeRules = ['banner_name' => 'required',];
    }

    public function indexHomeBanner() {
        return $this->response->jsonResponse(false,"Banner Details Fetched Successfully", HomeBanner::orderBy('id', 'desc')->get(), 100);
    }

    public function store(Request $request) {
        $validate = $this->response->validate($request->all(), $this->storeRules);
        if($validate === true) {
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'store'), HomeBanner::create($request->all()), 101);
        } else {
            return $validate;
        }
    }

    public function show($id) {
        return $this->response->jsonResponse(false, $this->response->message('Banner', 'show'), $this->findBanner($id), 102);
    }

    public function updateHomeBanner(Request $request) {
        $validate = $this->response->validate($request->all(), ['banner_name' => ['required']]);
        if($validate === true) {
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'update'), $this->findBanner($request->id)->update($request->all()), 103);
        } else {
            return $validate;
        }
    }

    public function destroy($id) {
        $size = $this->findBanner($id);
        if($size) {
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'destroy'), $size->delete(), 104);
        }
        return $this->response->jsonResponse(true, 'Banner Not Exists', [], 105);
    }

    public function findBanner($id) {
        return HomeBanner::find($id);
    }

    public function homeBannerSwitch($id) {
        $size = $this->findBanner($id);
        if($size) {
            $value = $size->active_status === 1 ? 0 : 1;
            $msg = $value === 0 ? 'Deactivated': 'Activated';
            return $this->response->jsonResponse(false, 'Banner '.$msg.' SuccessFully', $size->update(['active_status' => $value]), 106);
        }
        return $this->response->jsonResponse(true, 'HomeBanner Not Exists', [], 107);
    }

    public function imageUpdateHomeBanner(Request $request) {
        $getBanner = $this->findBanner($request['banner_id']);
        if($request->hasFile('banner_image')) {
            $file = $request->file('banner_image');
            $name = $this->response->generateSlug($getBanner['banner_name']);
            $uploadUrl = $this->response->cloudinaryImage($request->file('banner_image'), 'Banner', $name);
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'image'), $getBanner->update(['banner_image' => $uploadUrl]), 108);
        } else {
            return $this->response->jsonResponse(true, 'Image Banner is too high', [], 109);
        }
    }


    public function searchHomeBanner($search){
        if($search === "null") {
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'search'), [], 110);
        }
        return $this->response->jsonResponse(false, $this->response->message('Banner', 'search'), HomeBanner::where('banner_name', 'LIKE', '%'.$search.'%')->get(), 111);
    }
}
